# Version vom 29.11.07 (MO)

# Beim Schafkopf nie mehr selber verzweifelt Spielstnde oder Preise berechnen,
# das macht jetzt alles die folgende Funktion:

# Funktion, um die Ergebnisse einer gepflegten Schafkopfrunde zu protokollieren.
# Nach Abfragen der Parameter berechnet sie den Preis des jeweiligen Spiels, 
# in einer Verlaufsgraphik werden die Kontostnde der Mitspieler mitgezeichnet.
# Am Ende wird eine Matrix aller Kontostnde ausgegeben, sowie auf Wunsch 
# eine kleine Statistik. In der ausgegebenen Matrix sind neben den Kontostnden
# die Art des jeweiligen Spiels (Rufspiel, Solo, etc.) eingetragen, sowie die 
# Variable "Spielrunde", die nur dann wichtig ist, wenn ein alter Datensatz integriert 
# werden soll ("Spielrunde" meint also nicht das jeweils gespielte Spiel und bleibt 
# somit fr einen ganzen Abend gleich!)

# Folgende Spiele kennt das Programm:
# Rufspiel, Solo, Venz, Geier, Farbvenz, Farbgeier, Du, Sie

# Auerdem kann man mit oder ohne Stock spielen. Falls mit Stock, kann man zustzlich
# whlen zwischen den Optionen "Stock aufdoppeln" und "normal"

# Die Preise fr Rufspiel, Solo, Schneider und Schneider/Schwarz legt man bei
# Spielstart fest

# es ist mglich, einen frheren Datensatz zu integrieren (Objekt "alt"), falls die Spielernamen 
# bereinstimmen und der Datensatz in einer 6 x n (ohne Stock) bzw. einer 7 x n Matrix vorliegt,
# wobei die ersten vier Zeilen die Kontostnde der Spieler sind, die 5. Zeile die Art des Spiels,
# bei "mit Stock" die 6. der Stock und die 7. die Spielrunde, bei "ohne Stock" die 6. die Spielrunde.


# Gestartet wird mit "schafkopf()" oder schafkopf(alt="Name.des.alten.Objekts")

# Geschrieben im November 2007 von Michael Obermeier


schafkopf <- function(alt=NULL){
  # Ja- und Nein-Vektoren vergeben (fr sptere Abfragen)
  ja <- c("j","ja","y","yes","si","z","nai","freilich","JA","Ja")
  nein <- c("nein","no","nee","niemals","n","oxi","NEIN","Nein")
  
 if(is.null(alt)==T){
  # Begrung
  test <- 0
  while(test==0){
  begr <- readline("Hallo und herzlich willkommen. Sie mchten gerne Schafkopf spielen? ")
    if (begr %in% nein){
      stop("Was bemhen Sie mich dann?!\n")}
    else{
      if (begr %in% ja){
        cat("Sehr schn. Dann fangen wir an.\n")
        test <- 1}
      else{
        cat("Ich konnte Sie leider nicht verstehen: mein Wortschatz ist uerst limitiert.\n")}
        }
   }
   
  #############################################################################
  # Spielernamen vergeben
  test <- 0
  while(test==0){
    sp1 <- readline("Tippen Sie den Namen fr Spieler 1 ein: ")
    sp2 <- readline("Tippen Sie den Namen fr Spieler 2 ein: ")
    sp3 <- readline("Tippen Sie den Namen fr Spieler 3 ein: ")
    sp4 <- readline("Tippen Sie den Namen fr Spieler 4 ein: ")

    # Fehlerabfrage, ob zwei Spieler gleich heissen
    if (sp1 %in% c(sp2,sp3,sp4) | sp2 %in% c(sp3,sp4) | sp3 %in% c(sp4)){
      cat("Mindestens zwei Spieler haben den gleichen Namen!\n")
      noch <- readline("Namen nochmal eingeben? ")
      if(noch%in%nein)
        test <- 1  
      }
    else{
      frage <- readline(paste("Sind die Namen richtig geschrieben? (",sp1,sp2,sp3,sp4,")"))
      if(!(frage%in%nein))
        test <- 1
    }
   }

  #############################################################################
  # Zahlungsmodalitten vereinbaren
  ## testtest: Fr sptere Abfrage, ob alle Preise stimmen
  testtest <- 0
  while(testtest==0){
    ## Fr Kontrolle, ob Preis numerisch ist
    test <- 0
    while(test==0){
    ruf  <- readline("Wie teuer soll ein Rufspiel sein? ")
      if(!(is.na(as.numeric(ruf))))
        test=1
      else
       cat("Preis muss numerisch sein!\n")
    }
    test <- 0
   while(test==0){
   solo <- readline("Wie teuer soll ein Solo sein? ")
     if(!(is.na(as.numeric(solo))))
       test=1
     else
      cat("Preis muss numerisch sein!\n")
   }
    test <- 0
    while(test==0){
    schn <- readline("Was kostet der Schneider? ")
     if(!(is.na(as.numeric(schn))))
       test=1
     else
      cat("Preis muss numerisch sein!\n")
    }
    test <- 0
    while(test==0){
    schnschw <- readline("Was kostet der Schneider/Schwarz (zustzlich zum Schneider)? ")
      if(!(is.na(as.numeric(schnschw))))
        test=1
      else
       cat("Preis muss numerisch sein!\n")
    }
    sicher <- readline(paste("Stimmen alle Preise? (Rufspiel: ",ruf,", Solo: ",solo,
                             ", Schneider: ",schn,", Schneider/Schwarz: ",schnschw," ) "))
      if(sicher %in% nein)
        cat("Dann nochmal von vorn.\n")
      else
        testtest=1
  }

  #############################################################################
  # Mit Stock spielen?
  ## falls ja: erzeugte Variable: aufd= "a"(aufdoppeln) oder "n"(normal)
  ### bei Stockspiel: Stock wird nur bei Rufspielen ausbezahlt (an den Gewinner, egal
  ### ob Spieler oder Nicht-Spieler), bei Soli wird er NICHT angetastet
  test<-0
  while(test==0){
  stock <- readline("Soll es einen Stock geben? ")
    if(!(stock%in%ja | stock %in% nein))
      cat("Bitte mit 'ja' oder 'nein' antworten.\n")
    else{
      if(stock%in%ja){
        testtest<-0
        while(testtest==0){        
        aufd <- readline("Soll der Stock aufgedoppelt ('a') oder mit dem normalen Spieleinsatz aufgefllt ('n') werden? ")
          if(!(aufd%in%c("a","n")))
            cat("Bitte 'a' fr 'aufdoppeln' oder 'n' fr 'normal' eingeben.\n")
          else{
            testtest<-1
            cat("Zur Info: Stock wird nur bei Rufspielen an die Spieler ausbezahlt. Verlieren diese, mssen sie den Stock aufdoppeln\n")
          }
        }
        stock<-TRUE
        test<-1
      }
      else{
        stock<-FALSE
        test<-1
      }
    }
  }

  

  
# Ende "es gibt keinen alten Datensatz"
 }  

  
    #############################################################################
    # Datenmatrix erstellen
    # dat_test: Test, ob alter und neuer Datensatz zusammenpassen (fr den Index i spter)
    dat_test<-0
    # ID-Variable, ob es einen alten Datensatz gibt
    neu <- FALSE

     ## Filtern: gibt es einen alten Datensatz, der eingebunden werden soll?
    if(is.null(alt)==TRUE){
      ## Filtern: Stock oder nicht
      if(stock==FALSE){
         dat <- matrix(c(rep(0,5),1),ncol=1)
         rownames(dat) <- c(sp1[1],sp2[1],sp3[1],sp4[1],"Art","Spielrunde")
      }else{
         dat <- matrix(c(rep(0,6),1),ncol=1)
         rownames(dat) <- c(sp1[1],sp2[1],sp3[1],sp4[1],"Art","Stock","Spielrunde")                
      }
    }else{
        # berprfen, ob alter Datensatz passt
        if(is.list(alt)==T){
        if(length(alt)==2){
        if(length(alt[[2]])==4){
        if(length(alt[[2]][1])==1 & length(alt[[2]][2])==1 & length(alt[[2]][3])==1 & length(alt[[2]][4])==1){
        if(is.na(as.numeric(alt[[2]][[1]]))==F &  is.na(as.numeric(alt[[2]][[2]]))==F & 
           is.na(as.numeric(alt[[2]][[3]]))==F &  is.na(as.numeric(alt[[2]][[4]]))==F){
        if(is.matrix(alt[[1]])==T){
          if(nrow(alt[[1]])==6){
          if(is.null(rownames(alt[[1]]))==F){
          if(is.numeric(alt[[1]])==T){
          if(rownames(alt[[1]])[5]=="Art" & rownames(alt[[1]])[6]=="Spielrunde"){
            dat <- matrix(c(rep(0,5),(alt[[1]][6,ncol(alt[[1]])]+1)),ncol=1)
            rownames(dat) <- rownames(alt[[1]])
            dat <- cbind(alt[[1]],dat)
            cat("Alter und neuer Datensatz wurden erfolgreich zusammengefgt.\n")      

            dat_neu <- matrix(c(rep(0,5),(alt[[1]][6,ncol(alt[[1]])]+1)),ncol=1)
            rownames(dat_neu) <- rownames(alt[[1]])            
            neu <- TRUE      
      
            # Preise
            ruf  <- as.numeric(alt[[2]][[1]])
            solo <- as.numeric(alt[[2]][[2]])
            schn <- as.numeric(alt[[2]][[3]])
            schnschw <- as.numeric(alt[[2]][[4]])
      
            # Spielernamen
            sp1 <- rownames(alt[[1]])[1]
            sp2 <- rownames(alt[[1]])[2]
            sp3 <- rownames(alt[[1]])[3]
            sp4 <- rownames(alt[[1]])[4]
            
            # Stock
            stock=FALSE

            j<-ncol(alt[[1]])

          }else
            dat_test <- 1
          }else 
            dat_test <- 1      
          }else 
            dat_test <- 1                             
        }else{
           if(nrow(alt[[1]])==7){
           if(is.null(rownames(alt[[1]]))==F){
           if(is.numeric(alt[[1]])==T){
           if(rownames(alt[[1]])[5]=="Art" & rownames(alt[[1]])[6]=="Stock" & rownames(alt[[1]])[7]=="Spielrunde"){            
            dat <- matrix(c(rep(0,6),(alt[[1]][7,ncol(alt[[1]])]+1)),ncol=1)
            rownames(dat) <- rownames(alt[[1]])
            dat <- cbind(alt[[1]],dat)
            cat("Alter und neuer Datensatz wurden erfolgreich zusammengefgt.\n")             

             # Warnung, falls im alten Datensatz noch ein Stock vorhanden ist: ist bld bei aufdoppeln...
             if(alt[[1]][6,ncol(alt[[1]])]!=0)
                warning("Es ist noch Geld im Stock der alten Spielrunde: Vorsicht, falls die Option 'Stock aufdoppeln' gewhlt wird!",immediate. = TRUE)

            
            dat_neu <- matrix(c(rep(0,6),(alt[[1]][7,ncol(alt[[1]])]+1)),ncol=1)
            rownames(dat_neu) <- rownames(alt[[1]])            
            neu <- TRUE             
            
            # Preise
            ruf  <- as.numeric(alt[[2]][[1]])
            solo <- as.numeric(alt[[2]][[2]])
            schn <- as.numeric(alt[[2]][[3]])
            schnschw <- as.numeric(alt[[2]][[4]])
      
            # Spielernamen
            sp1 <- rownames(alt[[1]])[1]
            sp2 <- rownames(alt[[1]])[2]
            sp3 <- rownames(alt[[1]])[3]
            sp4 <- rownames(alt[[1]])[4]
            
            # Stock
            stock=TRUE
            
            j<-ncol(alt[[1]])
            
            
         testtest<-0
          while(testtest==0){        
          aufd <- readline("Soll der Stock aufgedoppelt ('a') oder mit dem normalen Spieleinsatz aufgefllt ('n') werden? ")
            if(!(aufd%in%c("a","n")))
              cat("Bitte 'a' fr 'aufdoppeln' oder 'n' fr 'normal' eingeben.\n")
            else{
              testtest<-1
             cat("Zur Info: Stock wird nur bei Rufspielen an die Spieler ausbezahlt. Verlieren diese, mssen sie den Stock aufdoppeln\n")
           }
         }            

                        
          }else
            dat_test <- 1
          }else 
            dat_test <- 1      
          }else 
            dat_test <- 1
          }else 
            dat_test <- 1 
        }
       }else 
         dat_test <- 1 
       }else 
         dat_test <- 1 
       }else 
         dat_test <- 1 
       }else 
         dat_test <- 1
       }else 
         dat_test <- 1 
       }else 
         dat_test <- 1                                              
                        
        if(dat_test==1){
            cat("Alter und neuer Datensatz waren nicht kompatibel.\n")
            cat("Im Zweifelsfalle neu starten und evt. die Namen bzw. Dimensionen abgleichen.\n")
            neustart <- readline("Jetzt abbrechen? ")
            if(neustart%in%ja)
              stop("Na, dann ade.")
            dat <- matrix(c(rep(0,5),1),ncol=1)
            rownames(dat) <- c(sp1[1],sp2[1],sp3[1],sp4[1],"Art","Spielrunde")
           }   
      
  }           

                         


  
  #############################################################################
  # Synonym fr die Spieler, um schneller zu schreiben
  syn <- readline("Soll fr die Spieler ein Synonym verwendet werden (schnelleres Dateneintippen)? ")
  if(syn %in%ja){
    test<-0
    while(test==0){
      sp1 <- c(sp1[1],readline(paste(sp1," wird abgekrzt mit: ")))
      sp2 <- c(sp2[1],readline(paste(sp2," wird abgekrzt mit: ")))
      sp3 <- c(sp3[1],readline(paste(sp3," wird abgekrzt mit: ")))
      sp4 <- c(sp4[1],readline(paste(sp4," wird abgekrzt mit: ")))
      if(sp1[2] %in% c(sp2,sp3,sp4) | sp2[2] %in% c(sp3,sp4) | sp3[4] %in% c(sp4))
        cat("Synonyme sind nicht eindeutig\n")
      else
        test <- 1}
  }
  else{
    cat("Na, dann halt nicht.\n")}
  
  
  
  
   #############################################################################
   # Datensatz speichern
   test<-0
   while(test==0){
     speicher <- readline("Soll der Datensatz nach jeder Runde automatisch gespeichert werden? ")     
     if(speicher %in% ja){
        pfad     <- readline("Pfad eingeben, wo der Datensatz gespeichert werden soll (Pfad muss existieren, Schreibweise: z.B. D:/Schafkopf): ")
        dat_name <- readline("Name eingeben, unter dem der Datensatz gespeichert werden soll: ")
        daten <- list("Datensatz" = dat, "Kosten pro Spiel"=list("Rufspiel"=ruf,"Solo"=solo,"Schneider"=schn,"Schneider/Schwarz"=schnschw))     
        if(class(try(save(daten,file=file.path(pfad,paste(dat_name,".rData",sep="")))))!="try-error"){
          cat(paste("Der Datensatz wird unter ",paste(dat_name,".rData",sep="")," gespeichert.\n"))
          cat("Die Matrix selbst heit 'daten'.\n") 
          test<-1
        }else{
          cat("Bitte einen ordentlichen (vorhandenen!) Pfad angeben.\n")    
        }
      }else{
        if(speicher%in%nein)
          test<-1
        else
          cat("Bitte mit 'JA' oder 'NEIN' antworten.\n")
      }  
   }

  
   
   
  #############################################################################  
  # Spielrunden
  cat("Dann fangt mal schn zu spielen an!\n")
  

    
    # ID-Variablen erstellen
    if(is.null(alt)==TRUE)
      i <- 1
    else{
      if(dat_test!=1)
        i <- 1+ncol(alt[[1]])
      else
        i <- 1
    }
      
    aus <- 0
    sol <- c("S","s","Solo","solo","v","Venz","V","venz","Geier","G","g","geier","farbvenz","Farbvenz",
             "FV","fv","Farbgeier","farbgeier","FG","fg","Du","DU","du","d","D",
             "SIE","Sie","sie")
    norm <- c("R","r","Ruf","ruf","rufspiel","Rufspiel")
    
    
    
    
    
    ############################################################################
    # Da geht's los
    # bei aus==1: Spiel ist aus. logisch...
    while(aus==0){
      #globaler Test: wurde in einer Runde alles richtig eingegeben?
      testtest <- 0
      while(testtest==0){
      # Falls Stock: Abfrage
      stocktest<-FALSE
      if(stock==TRUE){
        test<-0
        while(test==0){
          zus <- readline(paste("Runde ",i,": Wurde zusammengeworfen? "))
          if(!(zus%in% ja | zus %in% nein))
            cat("Bitte mit 'ja' oder 'nein' antworten.\n")
          else{
            if(zus%in%ja){
              tat <- readline("Tatschlich zusammengeworfen? ")
              if(tat%in%ja){
                stocktest <- TRUE
                test<-1
              }
              if(tat%in%nein){
                cat("Da ist sich einer nicht so ganz sicher, hh?\n")
                test<-1
              }
              if(!(tat%in% ja | tat %in% nein))
                cat("Bitte mit 'ja' oder 'nein' antworten.\n")                
            }else{
            test<-1
            }
          }
        }
      }
      
    # Die folgenden Abfragen nur ttigen, wenn nicht zusammengeworfen und in einen Stock einbezahlt wird
    if(stocktest==FALSE){
      # Art des Spiels eingeben
      test <- 0
      while(test==0){
        art <- readline(paste("Runde ",i,": Welche Art von Spiel war es? "))
        if(!(art%in%sol | art %in%norm)){
          cat("Fr ein Rufspiel 'R' eingeben\n")
          cat("Fr ein Solo 'S' eingeben\n")
          cat("Fr einen Venz 'V' eingeben\n")
          cat("Fr einen Geier 'G' eingeben\n")
          cat("Fr einen Farbvenz 'FV' eingeben\n")
          cat("Fr einen Farbgeier 'FG' eingeben\n")
          cat("Fr einen Du 'D' eingeben\n")
          cat("Fr einen Sie 'Sie' eingeben\n")
          }else{
          test<-1}
      }
      
      # Wer hat gewonnen?
      #############################################################################
      ########################### Rufspiel
      
      if(art %in% norm){
        test <- 0
        while(test==0){
          gew1 <- readline("Wer hat gewonnen? (1. Spieler) ")
          gew2 <- readline("Wer hat gewonnen? (2. Spieler) ")
          # Fehlerabfragen
          if((gew1 %in% c(1,sp1) & gew2 %in% c(1,sp1)) |
             (gew1 %in% c(2,sp2) & gew2 %in% c(2,sp2)) |
             (gew1 %in% c(3,sp3) & gew2 %in% c(3,sp3)) |
             (gew1 %in% c(4,sp4) & gew2 %in% c(4,sp4))){
             cat("Ein Spieler kann nicht mit sich selber spielen!\n")}
          else{
            if(!(gew1 %in% c(1,sp1,2,sp2,3,sp3,4,sp4) & gew2 %in%c(1,sp1,2,sp2,3,sp3,4,sp4))){
              cat("Bitte Spielernamen, Synonyme oder Zahlen von 1 bis 4 eintippen.\n")}
            else{
              # Genaue Indizes vergeben fr die Gewinner
              if(gew1 %in% c(1,sp1))g1<-1
              if(gew1 %in% c(2,sp2))g1<-2
              if(gew1 %in% c(3,sp3))g1<-3
              if(gew1 %in% c(4,sp4))g1<-4
              if(gew2 %in% c(1,sp1))g2<-1
              if(gew2 %in% c(2,sp2))g2<-2
              if(gew2 %in% c(3,sp3))g2<-3
              if(gew2 %in% c(4,sp4))g2<-4
              test <- 1}
            }
        }
        
        # Falls was im Stock ist: waren die Gewinner die Spieler oder nicht?
        if(stock==TRUE & ncol(dat)>1){
        test <- 0
          while(test==0){
            if(dat[6,(i-1)]>0){
              gewinner <- c(sp1,sp2,sp3,sp4)
              selbst <- readline(paste("Waren",gewinner[g1],"und",gewinner[g2],"selbst Spieler? "))
              if(selbst %in% nein | selbst %in% ja)
                test <- 1
              else
                cat("Bitte mit 'ja' oder 'nein' antworten.\n")
            }else{
              selbst <- "ja"
              test <- 1
            }
          }
        }
        if(stock==TRUE & ncol(dat)==1){
          selbst <- "ja"  
        }
                
        # Gab es Laufende?
        test<-0
        while(test==0){
          lauf <- readline("Wie viele Laufende gab es? ")
          if(!(lauf%in%as.character(c(0,3:8))))
            cat("Bitte 0 oder eine Zahl zwischen 3 und 8 eingeben.\n")
          else
            test<-1
        }
        # Schneider oder Schneider schwarz?
        test<-0
        while(test==0){
          sch <- readline("War es ein Schneider(schwarz)-Spiel? (Nein: 0, Schneider: 1, Schneider/Schwarz:2) ")
          if(!(sch%in%as.character(0:2)))
            cat("Bitte eine ganze Zahl zwischen 0 und 2 eingeben.\n")
          else
            test<-1
        }
        # Gedoppelt? Wie oft?
        test<-0
        while(test==0){
          dop <- readline("Wie oft wurde gedoppelt? ")
          if(!(dop%in%as.character(0:8)))
            cat("Bitte eine ganze Zahl zwischen 0 und 8 eingeben.\n")
          else
            test<-1
        }
        # Abfrage: Richtig eingetippt?
        abfr <- readline(paste("Alles richtig eingetippt? (Sieger: ",g1,g2,", Laufende: ",
                         lauf,", Schneider: ",sch,", gedoppelt: ",dop," ) "))
        if(!(abfr%in%nein))
          testtest<-1
        else
          cat("Dann frag ich halt nochmal...\n")
        
        if(testtest==1){
        #############################################################################
        # Ergebnisse eintragen
        preis<-(as.numeric(ruf)+as.numeric(schn)*I(sch=="1")+
                (as.numeric(schn)+as.numeric(schnschw))*I(sch=="2")+
                as.numeric(lauf)*as.numeric(schn))*2^(as.numeric(dop))[1]
        if(i==1 | (i!=1 & dat_test==0)){
          if(i==1){
            dat[c(g1,g2),i]<- preis
            dat[which(!(1:4%in%c(g1,g2))),i]<- -preis
            dat[5,i]<-1
            dat_test <- 1
          }else{
            if(stock==FALSE){
              dat[c(g1,g2),i]<- dat[c(g1,g2),(i-1)]+preis
              dat[which(!(1:4%in%c(g1,g2))),i] <- dat[which(!(1:4%in%c(g1,g2))),(i-1)] - preis
              dat[5,i]<-1
              # aktueller Datensatz
              dat_neu[c(g1,g2),(i-j)]<- preis
              dat_neu[which(!(1:4%in%c(g1,g2))),(i-j)] <-  -preis
              dat_neu[5,(i-j)]<-1             
              dat_test <- 1 
            }else{
              # Muss der Stock vom Spieler aufgedoppelt werden?
              if(selbst%in%ja){
                dat[c(g1,g2),i]<- dat[c(g1,g2),(i-1)]+preis + 0.5*dat[6,(i-1)]
                dat[which(!(1:4%in%c(g1,g2))),i] <- dat[which(!(1:4%in%c(g1,g2))),(i-1)] - preis
                dat[5,i]<-1
                # aktueller Datensatz
                dat_neu[c(g1,g2),(i-j)]<- preis
                dat_neu[which(!(1:4%in%c(g1,g2))),(i-j)] <-  -preis
                dat_neu[5,(i-j)]<-1             
                dat_test <- 1 
              }else{
                dat[c(g1,g2),i]<- dat[c(g1,g2),(i-1)]+preis 
                dat[which(!(1:4%in%c(g1,g2))),i] <- dat[which(!(1:4%in%c(g1,g2))),(i-1)] - preis - 0.5*dat[6,(i-1)]
                dat[6,i] <- dat[6,(i-1)]*2
                dat[5,i] <- 1
                # aktueller Datensatz
                dat_neu[c(g1,g2),(i-j)]<- preis
                dat_neu[which(!(1:4%in%c(g1,g2))),(i-j)] <-  -preis
                dat_neu[5,(i-j)]<-1            
                dat_test <- 1               
              }            
            }        
          }
        }else{
          # Abfrage, ob mit Stock gespielt wird
          if(stock==FALSE){
            dat <- cbind(dat,c(rep(0,5),dat[6,(i-1)]))
            dat[c(g1,g2),i]<- dat[c(g1,g2),(i-1)]+preis
            dat[which(!(1:4%in%c(g1,g2))),i] <- dat[which(!(1:4%in%c(g1,g2))),(i-1)] - preis
            dat[5,i]<-1
            if(neu==T){
              dat_neu <- cbind(dat_neu,c(rep(0,5),dat_neu[6,((i-j)-1)]))
              dat_neu[c(g1,g2),(i-j)]<- dat_neu[c(g1,g2),((i-j)-1)]+preis
              dat_neu[which(!(1:4%in%c(g1,g2))),(i-j)] <- dat_neu[which(!(1:4%in%c(g1,g2))),((i-j)-1)] - preis
              dat_neu[5,(i-j)]<-1            
            }
          }else{
            if(selbst%in%ja){
              dat <- cbind(dat,c(rep(0,6),dat[7,(i-1)])) 
              dat[c(g1,g2),i]<- dat[c(g1,g2),(i-1)]+preis+0.5*dat[6,(i-1)] 
              dat[which(!(1:4%in%c(g1,g2))),i] <- dat[which(!(1:4%in%c(g1,g2))),(i-1)] - preis 
              dat[5,i]<-1 
              if(neu==T){
                dat_neu <- cbind(dat_neu,c(rep(0,6),dat_neu[7,((i-j)-1)])) 
                dat_neu[c(g1,g2),(i-j)]<- dat_neu[c(g1,g2),((i-j)-1)]+preis+0.5*dat_neu[6,((i-j)-1)] 
                dat_neu[which(!(1:4%in%c(g1,g2))),(i-j)] <- dat_neu[which(!(1:4%in%c(g1,g2))),((i-j)-1)] - preis 
                dat_neu[5,(i-j)]<-1             
              }
            }else{
              dat <- cbind(dat,c(rep(0,6),dat[7,(i-1)])) 
              dat[c(g1,g2),i]<- dat[c(g1,g2),(i-1)]+preis 
              dat[which(!(1:4%in%c(g1,g2))),i] <- dat[which(!(1:4%in%c(g1,g2))),(i-1)] - preis - 0.5*dat[6,(i-1)]
              dat[6,i] <- dat[6,(i-1)]*2
              dat[5,i]<-1 
              if(neu==T){
                dat_neu <- cbind(dat_neu,c(rep(0,6),dat_neu[7,((i-j)-1)])) 
                dat_neu[c(g1,g2),(i-j)]<- dat_neu[c(g1,g2),((i-j)-1)]+preis 
                dat_neu[which(!(1:4%in%c(g1,g2))),(i-j)] <- dat_neu[which(!(1:4%in%c(g1,g2))),((i-j)-1)] - preis -0.5*dat_neu[6,((i-j)-1)]
                dat_neu[6,(i-j)] <- dat_neu[6,((i-j)-1)]*2
                dat_neu[5,(i-j)]<-1             
              }            
            }                                          
          }
        }
      # Ende Rufspiel
      }
      }
      
      #############################################################################
      ## Solo etc.
      if(art %in% sol){
      test<-0      
      # Wer hat gespielt?
      while(test==0){
        wer_sp <- readline("Wer hat gespielt? ")
        if(!(wer_sp %in% c(sp1,sp2,sp3,sp4,1:4)))                              
          cat("Das ist kein gltiger Spielername.\n")         
        if(wer_sp%in%c(sp1,1)){
          wer <- c(sp1[1],1)
          test<-1
          }
        if(wer_sp%in%c(sp2,2)){
          wer <- c(sp2[1],2)
          test<-1
          }
        if(wer_sp%in%c(sp3,3)){
          wer <- c(sp3[1],3)
          test<-1
          }
        if(wer_sp%in%c(sp4,4)){
          wer <- c(sp4[1],4)
          test<-1
          } 
        }
        
      # Filter fr einen Sie
      if(!(art %in% sol[26:28])){  
        
      # Wer hat gewonnen?
      test<-0
      while(test==0){
        gewo <- readline(paste("Hat ",wer[1]," selbst gewonnen? "))
        if(gewo%in%ja){
          gew <- wer[2]
          test <- 1
          }
        if(gewo%in%nein){
          gew <- which(!(1:4%in%wer[2]))
          test<-1
          }
        if(!(gewo%in%c(ja,nein))){
          cat("Nochmal: JA oder NEIN:\n")
          }
        }        
        # Gab es Laufende?
        test<-0
        while(test==0){
          lauf <- readline("Wie viele Laufende gab es? ")
          if(!(lauf%in%as.character(c(0,2:8))))
            cat("Bitte 0 oder eine Zahl grer 1 eingeben.\n")
          else
            test<-1
        }
        # Filtern, ob es ein DU war
        if(art %in% sol[21:25]){
          if(length(gew)==1)
            sch<-2
          else
            sch<-0
        }else{
        # Schneider oder Schneider schwarz?
        test<-0
        while(test==0){
          sch <- readline("War es ein Schneider(schwarz)-Spiel? (Nein: 0, Schneider: 1, Schneider/Schwarz:2) ")
          if(!(sch%in%as.character(0:2)))
            cat("Bitte eine ganze Zahl zwischen 0 und 2 eingeben.\n")
          else
            test<-1
        }
        }
        # Gedoppelt? Wie oft?
        test<-0
        while(test==0){
          if(!(art%in%sol[21:25])){
            dop <- readline("Wie oft wurde gedoppelt? ")
            if(!(dop%in%as.character(0:8)))
              cat("Bitte eine ganze Zahl zwischen 0 und 8 eingeben.\n")
            else
              test<-1
          }
          else{
            dop <- readline("Wie oft wurde zustzlich zum Du gedoppelt? ")
            if(!(dop%in%as.character(0:8)))
              cat("Bitte eine ganze Zahl zwischen 0 und 8 eingeben.\n")
            else{
              test<-1
              dop <- as.numeric(dop) + 1              
              }
          }

        }
        
        # Ende Filter "Sie"
        }else{
          gew<-wer[2]
        }
        
        # Abfrage: Richtig eingetippt?
        ## "normale" Soli
        if(!(art%in%sol[21:28])){
          if(length(gew)==1){
            abfr <- readline(paste("Alles richtig eingetippt? (Spieltyp: ",art," Spieler ",
                            gew," hat gewonnen, Laufende: ",lauf,", Schneider: ",sch,", gedoppelt: ",dop," ) "))
            }else{
            abfr <- readline(paste("Alles richtig eingetippt? (Spieltyp: ",art," Spieler ",
                            wer[1]," hat verloren, Laufende: ",lauf,", Schneider: ",sch,", gedoppelt: ",dop," ) "))            
            }
        }
        ## Abfrage bei DU
        if(art %in% sol[21:25]){
          if(length(gew)==1){        
            abfr <- readline(paste("Alles richtig eingetippt? (Spieltyp: ",art," Spieler ",
                            wer[1]," hat gewonnen, Laufende: ",lauf,", gedoppelt insgesamt: ",dop," ) ")) 
           }else{
            abfr <- readline(paste("Alles richtig eingetippt? (Spieltyp: ",art," Spieler ",
                            wer[1]," hat verloren, Laufende: ",lauf,", gedoppelt insgesamt: ",dop," ) ")) 
           }         
        }
        ## Abfrage bei SIE
        if(art %in% sol[26:28]){
          abfr <- readline("War das wirklich ein Sie?! ")          
        }        
        if(!(abfr%in%nein)){
          testtest<-1
        }else{
          cat("Dann frag ich halt nochmal...\n")
          }
        
        
        if(testtest==1){
        #############################################################################        
        # Ergebnisse eintragen
        if(!(art%in%sol[26:28])){
          preis<-(as.numeric(solo)+as.numeric(schn)*I(sch=="1")+
                  (as.numeric(schn)+as.numeric(schnschw))*I(sch=="2")+
                  as.numeric(lauf)*as.numeric(schn))*2^(as.numeric(dop))[1]
        }else{
          preis<-(as.numeric(solo)+(as.numeric(schn)+as.numeric(schnschw))+
                 8*as.numeric(schn))*2
        }
        if(i==1 | (i!=1 & dat_test==0)){
        if(i==1){
          if(length(gew)==1){
            dat[as.numeric(gew),i]<- (preis*3)
            dat[which(!(1:4%in%gew)),i]<- -preis
            }else{
            dat[as.numeric(gew),i]<- preis
            dat[which(!(1:4%in%gew)),i]<- -(preis*3)
            }
          if(art%in%sol[1:4])dat[5,i]<-2
          if(art%in%sol[5:8])dat[5,i]<-3
          if(art%in%sol[9:12])dat[5,i]<-4
          if(art%in%sol[13:16])dat[5,i]<-5
          if(art%in%sol[17:20])dat[5,i]<-6
          if(art%in%sol[21:25]){
            dat[5,i]<-7
            if(length(gew)==1)
              cat("Nicht schlecht, Herr Specht... Gratuliere!\n")
            else
              cat("Das ging wohl in die Hose...\n")
            }
          if(art%in%sol[26:28]){
            dat[5,i]<-8
            cat("Wow, das ist ja der Waaaaahnsinn!\n")
            } 
          dat_test <- 1
        }else{
          if(length(gew)==1){
            dat[as.numeric(gew),i]<- dat[as.numeric(gew),(i-1)]+preis*3
            dat[which(!(1:4%in%gew)),i] <- dat[which(!(1:4%in%gew)),(i-1)] - preis
            if(neu==T){
              dat_neu[as.numeric(gew),(i-j)]<- preis*3
              dat_neu[which(!(1:4%in%gew)),(i-j)] <-  - preis            
            }
          }else{
            dat[as.numeric(gew),i]<- dat[as.numeric(gew),(i-1)]+preis
            dat[which(!(1:4%in%gew)),i] <- dat[which(!(1:4%in%gew)),(i-1)] - preis*3
            if(neu==T){
              dat_neu[as.numeric(gew),(i-j)]<- preis
              dat_neu[which(!(1:4%in%gew)),(i-j)] <- - preis*3            
            } 
          }
          if(art%in%sol[1:4])dat[5,i]<-2
          if(art%in%sol[5:8])dat[5,i]<-3
          if(art%in%sol[9:12])dat[5,i]<-4
          if(art%in%sol[13:16])dat[5,i]<-5
          if(art%in%sol[17:20])dat[5,i]<-6
          if(art%in%sol[21:25]){
            dat[5,i]<-7
            if(length(gew)==1)
              cat("Nicht schlecht, Herr Specht... Gratuliere!\n")
            else
              cat("Das ging wohl in die Hose...\n")
            }
          if(art%in%sol[26:28]){
            dat[5,i]<-8
            cat("Wow, das ist ja der Waaaaahnsinn!\n")
            }
           if(neu==T){
              if(art%in%sol[1:4])dat_neu[5,(i-j)]<-2
              if(art%in%sol[5:8])dat_neu[5,(i-j)]<-3
              if(art%in%sol[9:12])dat_neu[5,(i-j)]<-4
              if(art%in%sol[13:16])dat_neu[5,(i-j)]<-5
              if(art%in%sol[17:20])dat_neu[5,(i-j)]<-6
              if(art%in%sol[21:25])dat_neu[5,(i-j)]<-7
              if(art%in%sol[26:28])dat_neu[5,(i-j)]<-8          
           }            
          dat_test <- 1        
        }
        }
        else{
          # Abfrage, ob mit oder ohne Stock gespielt wird
          if(stock==FALSE){
            dat <- cbind(dat,c(rep(0,5),dat[6,(i-1)]))
            if(neu==TRUE){
               dat_neu <- cbind(dat_neu,c(rep(0,5),dat_neu[6,((i-j)-1)]))
            }
          }else{
            dat <- cbind(dat,c(rep(0,5),dat[6:7,(i-1)]))
            if(neu==TRUE){
              dat_neu <- cbind(dat_neu,c(rep(0,5),dat_neu[6:7,((i-j)-1)]))
            }
          }
          if(length(gew)==1){
            dat[as.numeric(gew),i]<- dat[as.numeric(gew),(i-1)]+preis*3
            dat[which(!(1:4%in%gew)),i] <- dat[which(!(1:4%in%gew)),(i-1)] - preis
            if(neu==T){
              dat_neu[as.numeric(gew),(i-j)]<- dat_neu[as.numeric(gew),((i-j)-1)]+preis*3
              dat_neu[which(!(1:4%in%gew)),(i-j)] <- dat_neu[which(!(1:4%in%gew)),((i-j)-1)] - preis            
            }
          }else{
           dat[as.numeric(gew),i]<- dat[as.numeric(gew),(i-1)]+preis
           dat[which(!(1:4%in%gew)),i] <- dat[which(!(1:4%in%gew)),(i-1)] - preis*3 
           if(neu==T){
              dat_neu[as.numeric(gew),(i-j)]<- dat_neu[as.numeric(gew),((i-j)-1)]+preis
              dat_neu[which(!(1:4%in%gew)),(i-j)] <- dat_neu[which(!(1:4%in%gew)),((i-j)-1)] - preis*3
           }         
          }
          if(art%in%sol[1:4])dat[5,i]<-2
          if(art%in%sol[5:8])dat[5,i]<-3
          if(art%in%sol[9:12])dat[5,i]<-4
          if(art%in%sol[13:16])dat[5,i]<-5
          if(art%in%sol[17:20])dat[5,i]<-6
          if(art%in%sol[21:25]){
            dat[5,i]<-7
            if(length(gew)==1)
              cat("Nicht schlecht, Herr Specht... Gratuliere!\n")
            else
              cat("Das ging wohl in die Hose...\n")
            }
          if(art%in%sol[26:28]){
            dat[5,i]<-8
            cat("Wow, das ist ja der Waaaaahnsinn!\n")
            }
           if(neu==T){
              if(art%in%sol[1:4])dat_neu[5,(i-j)]<-2
              if(art%in%sol[5:8])dat_neu[5,(i-j)]<-3
              if(art%in%sol[9:12])dat_neu[5,(i-j)]<-4
              if(art%in%sol[13:16])dat_neu[5,(i-j)]<-5
              if(art%in%sol[17:20])dat_neu[5,(i-j)]<-6
              if(art%in%sol[21:25])dat_neu[5,(i-j)]<-7
              if(art%in%sol[26:28])dat_neu[5,(i-j)]<-8          
           }          
        }        
      # Ende testtest==1
      }
      # Ende Solo etc.      
      }
      # Ende: nicht zusammengeworfen
      }else{
        if(aufd=="a"){
          if(i==1 | (i!=1 & dat_test==0)){
            # ifelse-Statement arbeitet nicht vektoriell!!!
            if(i==1){
              dat[1:4,i] <- -as.numeric(ruf)

            }else{
              dat[1:4,i] <- dat[1:4,(i-1)]-as.numeric(ruf)
              if(neu==TRUE){
                dat_neu[1:4,(i-j)] <- -as.numeric(ruf)
              }
            }
            # Ende ifelse
            dat[6,i]   <- 4*as.numeric(ruf)
            if(neu==TRUE){
              dat_neu[6,(i-j)]   <- 4*as.numeric(ruf)
            }
            dat_test <- 1 
          }else{
            dat <- cbind(dat,c(rep(0,6),dat[7,ncol(dat)]))                     
            if(neu==TRUE){
               dat_neu <- cbind(dat_neu,c(rep(0,6),dat_neu[7,ncol(dat_neu)]))
            }
            # ifelse-Statement arbeitet nicht vektoriell!!!
            if(dat[6,(i-1)]==0){
              dat[1:4,i] <- dat[1:4,(i-1)]-as.numeric(ruf)
              if(neu==TRUE){
                dat_neu[1:4,(i-j)] <- dat_neu[1:4,((i-j)-1)]-as.numeric(ruf)
              }
            }
            else{
              dat[1:4,i] <- dat[1:4,(i-1)]-dat[6,(i-1)]/4 
              if(neu==TRUE){
                 dat_neu[1:4,(i-j)] <- dat_neu[1:4,((i-j)-1)]-dat_neu[6,((i-j)-1)]/4
              }
            }
            # Ende ifelse
            dat[6,i]   <- ifelse(dat[6,(i-1)]==0,4*as.numeric(ruf),dat[6,(i-1)]*2)
            if(neu==TRUE){
              dat_neu[6,(i-j)]   <- ifelse(dat_neu[6,((i-j)-1)]==0,4*as.numeric(ruf),dat_neu[6,((i-j)-1)]*2)     
            }
          }
        }else{
         if(i==1 | (i!=1 & dat_test==0)){
            dat[1:4,i] <- ifelse(i==1,-as.numeric(ruf),dat[1:4,(i-1)]-as.numeric(ruf)) 
            dat[6,i]   <- 4*as.numeric(ruf) 
            if(neu==TRUE){
              dat_neu[1:4,(i-j)] <- -as.numeric(ruf)    
            }
            dat_test <- 1
          }else{
            dat <- cbind(dat,c(rep(0,6),dat[7,ncol(dat)]))  
            dat[1:4,i] <- dat[1:4,(i-1)]-as.numeric(ruf)
            dat[6,i]   <- dat[6,(i-1)]+4*as.numeric(ruf)
            if(neu==TRUE){
              dat_neu <- cbind(dat_neu,c(rep(0,6),dat[7,ncol(dat_neu)]))  
              dat_neu[1:4,(i-j)] <- dat_neu[1:4,((i-j)-1)]-as.numeric(ruf)
              dat_neu[6,(i-j)]   <- dat_neu[6,((i-j)-1)]+4*as.numeric(ruf)            
            }
          }        
        }
        i<-i+1    
        
      #Zwischenergebnis plotten 
      if(neu==FALSE){
      par(mfrow=c(1,1)) 
      lim<-c(min(dat[c(1:4,6),max(1,(ncol(dat)-40)):ncol(dat)]),max(dat[c(1:4,6),max(1,(ncol(dat)-40)):ncol(dat)]))
      plot((max(1,(ncol(dat)-40)):ncol(dat)),dat[1,(max(1,(ncol(dat)-40)):ncol(dat))],
           type="b",las=1,ylim=lim,ylab="Kontostand",
           xlab="Spiele",main="Spielverlauf",xaxt="n")
      axis(1,label=(max(1,(ncol(dat)-40)):ncol(dat)),at=(max(1,(ncol(dat)-40)):ncol(dat)))
      lines((max(1,(ncol(dat)-40)):ncol(dat)),dat[2,(max(1,(ncol(dat)-40)):ncol(dat))],
           type="b",col=2,lty=2)
      lines((max(1,(ncol(dat)-40)):ncol(dat)),dat[3,(max(1,(ncol(dat)-40)):ncol(dat))],
           type="b",col=3,lty=3)    
      lines((max(1,(ncol(dat)-40)):ncol(dat)),dat[4,(max(1,(ncol(dat)-40)):ncol(dat))],
           type="b",col=4,lty=4)      
      lines((max(1,(ncol(dat)-40)):ncol(dat)),dat[6,(max(1,(ncol(dat)-40)):ncol(dat))],
              type="b",col=5,lty=5)
      legend("top",bty="n",legend=c(paste(sp1[1]," (",dat[1,ncol(dat)],")"),paste(sp2[1]," (",dat[2,ncol(dat)],")"),
            paste(sp3[1]," (",dat[3,ncol(dat)],")"),paste(sp4[1]," (",dat[4,ncol(dat)],")"),
            paste("Stock (",dat[6,ncol(dat)],")")),col=1:5,lty=1:5) 
       abline(h=0)
      }else{
      
      par(mfrow=c(2,1),mar=c(3,3,2,1)+0.01)
      lim<-c(min(dat[c(1:4,6),max(1,(ncol(dat)-20)):ncol(dat)]),max(dat[c(1:4,6),max(1,(ncol(dat)-20)):ncol(dat)]))
      plot((max(1,(ncol(dat)-40)):ncol(dat)),dat[1,(max(1,(ncol(dat)-40)):ncol(dat))],
           type="b",las=1,ylim=lim,ylab="Kontostand",
           xlab="Spiele",main="Spielverlauf (alle Spiele)",xaxt="n")
      axis(1,label=(max(1,(ncol(dat)-40)):ncol(dat)),at=(max(1,(ncol(dat)-40)):ncol(dat)))
      lines((max(1,(ncol(dat)-40)):ncol(dat)),dat[2,(max(1,(ncol(dat)-40)):ncol(dat))],
           type="b",col=2,lty=2)
      lines((max(1,(ncol(dat)-40)):ncol(dat)),dat[3,(max(1,(ncol(dat)-40)):ncol(dat))],
           type="b",col=3,lty=3)    
      lines((max(1,(ncol(dat)-40)):ncol(dat)),dat[4,(max(1,(ncol(dat)-40)):ncol(dat))],
           type="b",col=4,lty=4)      
      lines((max(1,(ncol(dat)-40)):ncol(dat)),dat[6,(max(1,(ncol(dat)-40)):ncol(dat))],
              type="b",col=5,lty=5)
      legend("top",bty="n",legend=c(paste(sp1[1]," (",dat[1,ncol(dat)],")"),paste(sp2[1]," (",dat[2,ncol(dat)],")"),
            paste(sp3[1]," (",dat[3,ncol(dat)],")"),paste(sp4[1]," (",dat[4,ncol(dat)],")"),
            paste("Stock (",dat[6,ncol(dat)],")")),col=1:5,lty=1:5) 
       abline(h=0)
       abline(v=j+0.5)
       

      lim<-c(min(dat_neu[c(1:4,6),max(1,(ncol(dat_neu)-20)):ncol(dat_neu)]),max(dat_neu[c(1:4,6),max(1,(ncol(dat_neu)-20)):ncol(dat_neu)]))
      plot((max(1,(ncol(dat_neu)-20)):ncol(dat_neu)),dat_neu[1,(max(1,(ncol(dat_neu)-20)):ncol(dat_neu))],
           type="b",las=1,ylim=lim,ylab="Kontostand",
           xlab="Spiele",main="Spielverlauf (aktuelle Runde)")
      lines((max(1,(ncol(dat_neu)-20)):ncol(dat_neu)),dat_neu[2,(max(1,(ncol(dat_neu)-20)):ncol(dat_neu))],
           type="b",col=2,lty=2)
      lines((max(1,(ncol(dat_neu)-20)):ncol(dat_neu)),dat_neu[3,(max(1,(ncol(dat_neu)-20)):ncol(dat_neu))],
           type="b",col=3,lty=3)    
      lines((max(1,(ncol(dat_neu)-20)):ncol(dat_neu)),dat_neu[4,(max(1,(ncol(dat_neu)-20)):ncol(dat_neu))],
           type="b",col=4,lty=4)      
      lines((max(1,(ncol(dat_neu)-20)):ncol(dat_neu)),dat_neu[6,(max(1,(ncol(dat_neu)-20)):ncol(dat_neu))],
              type="b",col=5,lty=5)
      legend("top",bty="n",legend=c(paste(sp1[1]," (",dat_neu[1,ncol(dat_neu)],")"),paste(sp2[1]," (",dat_neu[2,ncol(dat_neu)],")"),
            paste(sp3[1]," (",dat_neu[3,ncol(dat_neu)],")"),paste(sp4[1]," (",dat_neu[4,ncol(dat_neu)],")"),
            paste("Stock (",dat_neu[6,ncol(dat_neu)],")")),col=1:5,lty=1:5) 
      abline(h=0)            
      }
      } 
            
      # Ende testtest: wurde alles richtig eingegeben?
      }
      
      
      
      
      #############################################################################
      # Zwischenergebnis anzeigen
      if(neu==FALSE){
      par(mfrow=c(1,1))
      if(stock==FALSE){
        lim<-c(min(dat[1:4,max(1,(ncol(dat)-40)):ncol(dat)]),max(dat[1:4,max(1,(ncol(dat)-40)):ncol(dat)]))
      }else{
        lim<-c(min(dat[c(1:4,6),max(1,(ncol(dat)-40)):ncol(dat)]),max(dat[c(1:4,6),max(1,(ncol(dat)-40)):ncol(dat)]))
      }
      plot((max(1,(ncol(dat)-40)):ncol(dat)),dat[1,(max(1,(ncol(dat)-40)):ncol(dat))],
           type="b",las=1,ylim=lim,ylab="Kontostand",
           xlab="Spiele",main="Spielverlauf",xaxt="n")
      axis(1,label=(max(1,(ncol(dat)-40)):ncol(dat)),at=(max(1,(ncol(dat)-40)):ncol(dat)))
      lines((max(1,(ncol(dat)-40)):ncol(dat)),dat[2,(max(1,(ncol(dat)-40)):ncol(dat))],
           type="b",col=2,lty=2)
      lines((max(1,(ncol(dat)-40)):ncol(dat)),dat[3,(max(1,(ncol(dat)-40)):ncol(dat))],
           type="b",col=3,lty=3)    
      lines((max(1,(ncol(dat)-40)):ncol(dat)),dat[4,(max(1,(ncol(dat)-40)):ncol(dat))],
           type="b",col=4,lty=4)
      abline(h=0)
      if(stock==TRUE){                                            
        lines((max(1,(ncol(dat)-40)):ncol(dat)),dat[6,(max(1,(ncol(dat)-40)):ncol(dat))],
              type="b",col=5,lty=5)
        legend("top",bty="n",legend=c(paste(sp1[1]," (",dat[1,ncol(dat)],")"),paste(sp2[1]," (",dat[2,ncol(dat)],")"),
            paste(sp3[1]," (",dat[3,ncol(dat)],")"),paste(sp4[1]," (",dat[4,ncol(dat)],")"),
            paste("Stock (",dat[6,ncol(dat)],")")),col=1:5,lty=1:5)              
      }else{
        legend("top",bty="n",legend=c(paste(sp1[1]," (",dat[1,ncol(dat)],")"),paste(sp2[1]," (",dat[2,ncol(dat)],")"),
            paste(sp3[1]," (",dat[3,ncol(dat)],")"),paste(sp4[1]," (",dat[4,ncol(dat)],")")),col=1:4,lty=1:4)      
      }
      }else{
      
      par(mfrow=c(2,1),mar=c(3,3,2,1)+0.01)
      if(stock==FALSE){
        lim<-c(min(dat[1:4,max(1,(ncol(dat)-40)):ncol(dat)]),max(dat[1:4,max(1,(ncol(dat)-40)):ncol(dat)]))
      }else{
        lim<-c(min(dat[c(1:4,6),max(1,(ncol(dat)-40)):ncol(dat)]),max(dat[c(1:4,6),max(1,(ncol(dat)-40)):ncol(dat)]))
      }
      plot((max(1,(ncol(dat)-40)):ncol(dat)),dat[1,(max(1,(ncol(dat)-40)):ncol(dat))],
           type="b",las=1,ylim=lim,ylab="Kontostand",
           xlab="Spiele",main="Spielverlauf (alle Spiele)",xaxt="n")
      axis(1,label=(max(1,(ncol(dat)-40)):ncol(dat)),at=(max(1,(ncol(dat)-40)):ncol(dat)))
      lines((max(1,(ncol(dat)-40)):ncol(dat)),dat[2,(max(1,(ncol(dat)-40)):ncol(dat))],
           type="b",col=2,lty=2)
      lines((max(1,(ncol(dat)-40)):ncol(dat)),dat[3,(max(1,(ncol(dat)-40)):ncol(dat))],
           type="b",col=3,lty=3)    
      lines((max(1,(ncol(dat)-40)):ncol(dat)),dat[4,(max(1,(ncol(dat)-40)):ncol(dat))],
           type="b",col=4,lty=4)
      abline(h=0)
      abline(v=j+0.5)
      if(stock==TRUE){                                            
        lines((max(1,(ncol(dat)-40)):ncol(dat)),dat[6,(max(1,(ncol(dat)-40)):ncol(dat))],
              type="b",col=5,lty=5)
        legend("top",bty="n",legend=c(paste(sp1[1]," (",dat[1,ncol(dat)],")"),paste(sp2[1]," (",dat[2,ncol(dat)],")"),
            paste(sp3[1]," (",dat[3,ncol(dat)],")"),paste(sp4[1]," (",dat[4,ncol(dat)],")"),
            paste("Stock (",dat[6,ncol(dat)],")")),col=1:5,lty=1:5)              
      }else{
        legend("top",bty="n",legend=c(paste(sp1[1]," (",dat[1,ncol(dat)],")"),paste(sp2[1]," (",dat[2,ncol(dat)],")"),
            paste(sp3[1]," (",dat[3,ncol(dat)],")"),paste(sp4[1]," (",dat[4,ncol(dat)],")")),col=1:4,lty=1:4)      
      }
       
       

      if(stock==FALSE){
        lim<-c(min(dat_neu[1:4,max(1,(ncol(dat_neu)-20)):ncol(dat_neu)]),max(dat_neu[1:4,max(1,(ncol(dat_neu)-20)):ncol(dat_neu)]))
      }else{
        lim<-c(min(dat_neu[c(1:4,6),max(1,(ncol(dat_neu)-20)):ncol(dat_neu)]),max(dat_neu[c(1:4,6),max(1,(ncol(dat_neu)-20)):ncol(dat_neu)]))
      }
      plot((max(1,(ncol(dat_neu)-20)):ncol(dat_neu)),dat_neu[1,(max(1,(ncol(dat_neu)-20)):ncol(dat_neu))],
           type="b",las=1,ylim=lim,ylab="Kontostand",
           xlab="Spiele",main="Spielverlauf (aktuelle Runde)",xaxt="n")
      axis(1,label=(max(1,(ncol(dat_neu)-20)):ncol(dat_neu)),at=(max(1,(ncol(dat_neu)-20)):ncol(dat_neu)))
      lines((max(1,(ncol(dat_neu)-20)):ncol(dat_neu)),dat_neu[2,(max(1,(ncol(dat_neu)-20)):ncol(dat_neu))],
           type="b",col=2,lty=2)
      lines((max(1,(ncol(dat_neu)-20)):ncol(dat_neu)),dat_neu[3,(max(1,(ncol(dat_neu)-20)):ncol(dat_neu))],
           type="b",col=3,lty=3)    
      lines((max(1,(ncol(dat_neu)-20)):ncol(dat_neu)),dat_neu[4,(max(1,(ncol(dat_neu)-20)):ncol(dat_neu))],
           type="b",col=4,lty=4)
      abline(h=0)
      if(stock==TRUE){                                            
        lines((max(1,(ncol(dat_neu)-20)):ncol(dat_neu)),dat_neu[6,(max(1,(ncol(dat_neu)-20)):ncol(dat_neu))],
              type="b",col=5,lty=5)
        legend("top",bty="n",legend=c(paste(sp1[1]," (",dat_neu[1,ncol(dat_neu)],")"),paste(sp2[1]," (",dat_neu[2,ncol(dat_neu)],")"),
            paste(sp3[1]," (",dat_neu[3,ncol(dat_neu)],")"),paste(sp4[1]," (",dat_neu[4,ncol(dat_neu)],")"),
            paste("Stock (",dat_neu[6,ncol(dat_neu)],")")),col=1:5,lty=1:5)              
      }else{
        legend("top",bty="n",legend=c(paste(sp1[1]," (",dat_neu[1,ncol(dat_neu)],")"),paste(sp2[1]," (",dat_neu[2,ncol(dat_neu)],")"),
            paste(sp3[1]," (",dat_neu[3,ncol(dat_neu)],")"),paste(sp4[1]," (",dat_neu[4,ncol(dat_neu)],")")),col=1:4,lty=1:4)      
      }
      
      }
      
      
      # Anzeigen, was das Spiel kostet
      cat(paste("Das Spiel kostet ",preis," Einheiten\n"))
      
      # Zwischenergebnis speichern
      if(speicher%in%ja){
        daten <- list("Datensatz" = dat, "Kosten pro Spiel"=list("Rufspiel"=ruf,"Solo"=solo,"Schneider"=schn,"Schneider/Schwarz"=schnschw))
        save(daten,file=file.path(pfad,paste(dat_name,".rData",sep="")))
      }
      
      
      
      #############################################################################
      # Wollen die Spieler aufhren?
      auf <- readline("Noch ein Spiel? ")
      if(auf %in% nein){
        auf <- readline("Tatschlich aufhren? ")
        if(!(auf %in% nein))
          aus <- 1
        else
          i <- i+1 }
      else
        i<-i+1
        
        
       
        
     # Ende Spielzeit        
     }


   
   
   
   #############################################################################
   # Kurzstatistik erstellen?
   stati <- readline("Soll eine Kurzstatistik erstellt werden? ")
   if(stati%in%ja){
        # Anzahl gewonner Spiele gesamt pro Spieler
        ## mit oder ohne Stock?
        gewSp <- rbind(dat[1:5,],matrix(rep(0,4*ncol(dat)),nrow=4))
        for(i in 1:ncol(dat)){
          for(j in 1:4){
            if(i==1){
              if(dat[j,i]>0)
              gewSp[(j+5),i] <- 1
            }else{
              if(dat[j,i]>dat[j,(i-1)])
              gewSp[(j+5),i] <- 1
            }
          }
        }
        zaehler<-rowSums(gewSp[6:9,])
        names(zaehler) <- c(sp1[1],sp2[1],sp3[1],sp4[1])
        
        # Anzahl Rufspiel,Soli,Venz,etc. gesamt
        soliStat        <-table(dat[5,])
        typ             <-c("Rufspiel","Solo","Venz","Geier","Farbvenz","Farbgeier","Du","Sie")
        a               <-as.numeric(names(soliStat))
        names(soliStat) <-typ[a]
        
        # Anzahl gespielter Soli pro Spieler
        soliStatSp1 <- table(gewSp[5,(gewSp[5,]!=1 & ((gewSp[6,]==1 & gewSp[7,]==0 & gewSp[8,]==0 & gewSp[9,]==0)|
                                                       gewSp[6,]==0 & gewSp[7,]==1 & gewSp[8,]==1 & gewSp[9,]==1))])
        if(length(soliStatSp1)==0)
          soliStatSp1 <- c(0)
        names(soliStatSp1)<-typ[as.numeric(names(soliStatSp1))]
        soliStatSp2 <- table(gewSp[5,(gewSp[5,]!=1 & ((gewSp[7,]==1 & gewSp[6,]==0 & gewSp[8,]==0 & gewSp[9,]==0)|
                                                       gewSp[7,]==0 & gewSp[6,]==1 & gewSp[8,]==1 & gewSp[9,]==1))])
        if(length(soliStatSp2)==0)
          soliStatSp2 <- c(0)
        names(soliStatSp2)<-typ[as.numeric(names(soliStatSp2))]
        soliStatSp3 <- table(gewSp[5,(gewSp[5,]!=1 & ((gewSp[8,]==1 & gewSp[6,]==0 & gewSp[7,]==0 & gewSp[9,]==0)|
                                                       gewSp[8,]==0 & gewSp[6,]==1 & gewSp[7,]==1 & gewSp[9,]==1))])
        if(length(soliStatSp3)==0)
          soliStatSp3 <- c(0)
        names(soliStatSp3)<-typ[as.numeric(names(soliStatSp3))]
        soliStatSp4 <- table(gewSp[5,(gewSp[5,]!=1 & ((gewSp[9,]==1 & gewSp[6,]==0 & gewSp[8,]==0 & gewSp[7,]==0)|
                                                       gewSp[9,]==0 & gewSp[6,]==1 & gewSp[8,]==1 & gewSp[7,]==1))])
        if(length(soliStatSp4)==0)
          soliStatSp4 <- c(0)
        names(soliStatSp4)<-typ[as.numeric(names(soliStatSp4))]
        
        # Anzahl gewonnener Soli pro Spieler
        soliStatSp1gew <- table(gewSp[5,(gewSp[5,]!=1 & gewSp[6,]==1 & gewSp[7,]==0 & gewSp[8,]==0 & gewSp[9,]==0)])
        if(length(soliStatSp1gew)==0)
          soliStatSp1gew <- c(0)
        names(soliStatSp1gew)<-typ[as.numeric(names(soliStatSp1gew))]
        soliStatSp2gew <- table(gewSp[5,(gewSp[5,]!=1 & gewSp[7,]==1 & gewSp[6,]==0 & gewSp[8,]==0 & gewSp[9,]==0)])
        if(length(soliStatSp2gew)==0)
          soliStatSp2gew <- c(0)
        names(soliStatSp2gew)<-typ[as.numeric(names(soliStatSp2gew))]
        soliStatSp3gew <- table(gewSp[5,(gewSp[5,]!=1 & gewSp[8,]==1 & gewSp[6,]==0 & gewSp[7,]==0 & gewSp[9,]==0)])
        if(length(soliStatSp3gew)==0)
          soliStatSp3gew <- c(0)
        names(soliStatSp3gew)<-typ[as.numeric(names(soliStatSp3gew))]
        soliStatSp4gew <- table(gewSp[5,(gewSp[5,]!=1 & gewSp[9,]==1 & gewSp[6,]==0 & gewSp[8,]==0 & gewSp[7,]==0)])
        if(length(soliStatSp4gew)==0)
          soliStatSp4gew <- c(0)
        names(soliStatSp4gew)<-typ[as.numeric(names(soliStatSp4gew))]
        
        # Test, ob alle gleich hufig gewonnen oder gleich hufig ein Solo gespielt bzw. gewonnen haben
        testGew       <- prop.test(zaehler,rep(ncol(dat),4))
        testSol       <- prop.test(c(sum(soliStatSp1),sum(soliStatSp2),sum(soliStatSp3),sum(soliStatSp4)),rep(ncol(dat),4))
        testSolGewAbs <- prop.test(c(sum(soliStatSp1gew),sum(soliStatSp2gew),sum(soliStatSp3gew),sum(soliStatSp4gew)),rep(ncol(dat),4))
        if(!(0%in%c(soliStatSp1,soliStatSp2,soliStatSp3,soliStatSp4))){
          testSolGewRel <- prop.test(c(sum(soliStatSp1gew),sum(soliStatSp2gew),sum(soliStatSp3gew),sum(soliStatSp4gew)),
                                     c(sum(soliStatSp1),sum(soliStatSp2),sum(soliStatSp3),sum(soliStatSp4)))
        }else{
          testSolGewRel <- NA
        }


      
  # Ergebnisausgabe
  stat <- list(list(zaehler[[1]],soliStatSp1,soliStatSp1gew),
               list(zaehler[[2]],soliStatSp2,soliStatSp2gew),
               list(zaehler[[3]],soliStatSp3,soliStatSp3gew),
               list(zaehler[[4]],soliStatSp4,soliStatSp4gew),                                                            
               "Test: alle haben gleich viele Spiele gewonnen"=testGew,
               "Test: Alle haben gleich viele Soli gespielt"=testSol,
               "Test: Alle haben gleich viele Soli absolut gesehen gewonnen"=testSolGewAbs,
               "Test: Alle haben gleich viele Soli relativ gesehen gewonnen"=testSolGewRel)
  names(stat)      <- c(sp1[1],sp2[1],sp3[1],sp4[1],names(stat)[5:8])
  names(stat[[1]]) <- c("Anzahl gewonnener Spiele","Anzahl gespielter Soli","Anzahl gewonnener Soli")
  names(stat[[2]]) <- c("Anzahl gewonnener Spiele","Anzahl gespielter Soli","Anzahl gewonnener Soli")
  names(stat[[3]]) <- c("Anzahl gewonnener Spiele","Anzahl gespielter Soli","Anzahl gewonnener Soli")
  names(stat[[4]]) <- c("Anzahl gewonnener Spiele","Anzahl gespielter Soli","Anzahl gewonnener Soli")
       
  #Gesamtergebnis
  if(neu==TRUE){
    res <- list("Datensatz (alles)" = dat,"Aktuelle Runde"=dat_neu, "Kosten pro Spiel"=list("Rufspiel"=ruf,"Solo"=solo,"Schneider"=schn,"Schneider/Schwarz"=schnschw),
                "Statistik" = stat)      
  }else{
    res <- list("Datensatz (alles)" = dat, "Kosten pro Spiel"=list("Rufspiel"=ruf,"Solo"=solo,"Schneider"=schn,"Schneider/Schwarz"=schnschw),
                "Statistik" = stat)   
  }
                  
   }else{
      cat("Na, dann viel Spa beim Selber-Rechnen!\n")
      #Gesamtergebnis
      if(neu==TRUE)
        res <- list("Datensatz" = dat, "Aktuelle Runde"=dat_neu,"Kosten pro Spiel"=list("Rufspiel"=ruf,"Solo"=solo,"Schneider"=schn,"Schneider/Schwarz"=schnschw))      
      else
        res <- list("Datensatz" = dat, "Kosten pro Spiel"=list("Rufspiel"=ruf,"Solo"=solo,"Schneider"=schn,"Schneider/Schwarz"=schnschw))
   }
   
   
   
    
    # Ergebnisausgabe

   res
}